!
!  Bookkeeping
!  New algorithm
!
      subroutine bookkeep
      use constants
      use variables
      use bookkeep_param
      use debug_variables
      implicit double precision (a-h,o-z)
      double precision :: sdx,sdy,sdz
      integer :: istat
      istat=0

! Brenner's algorithm is embedded in bre_caguts.f90
      if (bookkeep_algo == 3) return

      atime=dtime(btime)
      if (.not. allocated (knum)) then
         allocate (knum(n))
      endif

!      vave=sqrt(3.0d0*bl*temp/wm)
!      frc=rc+vave*2.0d0*dt*dble(nbk)*5.0d0
!      print *,'RC=',rc/ang
!      print *,'FRC=',frc/ang
      frc2=frc**2

! Check cell size, determine # of replica cells to be serched
      nrpx=0; nrpy=0; nrpz=0
!      if (pbcx) nrpx=int(frc*2.0/hmat(1,1))+1
!      if (pbcy) nrpy=int(frc*2.0/hmat(2,2))+1
!      if (pbcz) nrpz=int(frc*2.0/hmat(3,3))+1
      if (pbcx) nrpx=int(frc*2.0/sqrt(hmat(1,1)**2+hmat(2,1)**2+hmat(3,1)**2))+1
      if (pbcy) nrpy=int(frc*2.0/sqrt(hmat(1,2)**2+hmat(2,2)**2+hmat(3,2)**2))+1
      if (pbcz) nrpz=int(frc*2.0/sqrt(hmat(1,3)**2+hmat(2,3)**2+hmat(3,3)**2))+1
!      print *,'Replica cells searched:',nrpx,nrpy,nrpz
      if (n>1000) then
         iwarn=iwarn+1
         print *,'WARNING:'
         print *,'You deal with a large cell.'
         print *,'Region partitioning algorithm may help you.'
      endif
      if (bookkeep_algo == 2) go to 5000

!!! Normal algorithm
!!! Count and allocate list vector
      if ((.not.allocated (idpt)).and.(nbook>0)) then
         allocate (idpt(nbook,4))
      endif
 1000 continue
      if (.not. allocated (idpt)) then
         kns=0
         do k=1,n
            kn=0
            sxk=rx(k)
            syk=ry(k)
            szk=rz(k)
            do j=k,n
               if ((nrpx<=1).and.(nrpy<=1).and.(nrpz<=1)) then
                  sdx=sxk-rx(j)
                  sdy=syk-ry(j)
                  sdz=szk-rz(j)
                  ix=0; iy=0; iz=0
                  call search_neighbor(sdx,sdy,sdz,frc,ix,iy,iz,istat)
                  if (istat == 1) then
                     r2=sdx**2+sdy**2+sdz**2
                     if (r2 < frc2) then
                        kn=kn+1
                        kns=kns+1
                     endif
                  endif
               else
                  do ix=-nrpx,nrpx; do iy=-nrpy,nrpy; do iz=-nrpz,nrpz
                     sdx=sxk-rx(j)
                     sdy=syk-ry(j)
                     sdz=szk-rz(j)
                     call calc_replica(sdx,sdy,sdz,frc,ix,iy,iz,istat)
                     if (istat == 1) then
                        r2=sdx**2+sdy**2+sdz**2
                        if (r2 < frc2) then
                           kn=kn+1
                           kns=kns+1
                        endif
                     endif
                  enddo; enddo; enddo
               endif
            enddo
            knum(k)=kn
         enddo
         nbook=kns*1.5
         allocate (idpt(nbook,4))
      endif
      atime=dtime(btime)
      if (btime(2)>1) print *,'Bookkeep counting:',btime,'  sec'
!!! Count end
      kns=0
      do 3200 k=1,n
         kn=0
         sxk=rx(k)
         syk=ry(k)
         szk=rz(k)
         do 3300 j=k,n
            if ((nrpx<=1).and.(nrpy<=1).and.(nrpz<=1)) then
               sdx=sxk-rx(j)
               sdy=syk-ry(j)
               sdz=szk-rz(j)
               call search_neighbor(sdx,sdy,sdz,frc,ix,iy,iz,istat)
               if (istat == 1) then
                  r2=sdx**2+sdy**2+sdz**2
                  if (r2 < frc2) then
                     kn=kn+1
                     kns=kns+1
                     if (kns <= nbook) then
                        idpt(kns,1)=j
                        idpt(kns,2)=ix
                        idpt(kns,3)=iy
                        idpt(kns,4)=iz
                     else
                        print *,'nbook should be larger. expanded.'
                        print *,'Pls set larger nbook to save time'
                        deallocate (idpt)
                        go to 1000
                     endif
                  endif
               endif
            else
               do ix=-nrpx,nrpx; do iy=-nrpy,nrpy; do iz=-nrpz,nrpz
                  sdx=sxk-rx(j)
                  sdy=syk-ry(j)
                  sdz=szk-rz(j)
                  call calc_replica(sdx,sdy,sdz,frc,ix,iy,iz,istat)
                  if (istat == 1) then
                     r2=sdx**2+sdy**2+sdz**2
                     if (r2 < frc2) then
                        kn=kn+1
                        kns=kns+1
                        if (kns <= nbook) then
                           idpt(kns,1)=j
                           idpt(kns,2)=ix
                           idpt(kns,3)=iy
                           idpt(kns,4)=iz
                        else
                           print *,'nbook should be larger. expanded.'
                           print *,'Pls set larger nbook to save time'
                           deallocate (idpt)
                           go to 1000
                        endif
                     endif
                  endif
               enddo; enddo; enddo
            endif
 3300    continue
         knum(k)=kn
 3200 continue
      if (ilog == 1) then
         print *,'NUMBER OF BOOKKEEPING : ',kns
      endif
!      if (kns.gt.nbook) then
!         print *,'!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
!         print *,'!!! ERROR in BOOKKEEPING !!!'              
!         print *,'!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
!      endif

      atime=dtime(btime)
      print *,'Bookkeep (NORMAL algorithm)',btime,'  sec'
      return

!!! Double algorithm
!!! Count and allocate list vector
 5000 continue
      if (.not. allocated (idpt)) then
         kns=0
         do k=1,n
            kn=0
            sxk=rx(k)
            syk=ry(k)
            szk=rz(k)
            do j=1,n
               if ((nrpx<=1).and.(nrpy<=1).and.(nrpz<=1)) then
                  sdx=sxk-rx(j)
                  sdy=syk-ry(j)
                  sdz=szk-rz(j)
                  ix=0; iy=0; iz=0
                  call search_neighbor(sdx,sdy,sdz,frc,ix,iy,iz,istat)
                  if (istat == 1) then
                     r2=sdx**2+sdy**2+sdz**2
                     if (r2 < frc2) then
                        kn=kn+1
                        kns=kns+1
                     endif
                  endif
               else
                  do ix=-nrpx,nrpx; do iy=-nrpy,nrpy; do iz=-nrpz,nrpz
                     sdx=sxk-rx(j)
                     sdy=syk-ry(j)
                     sdz=szk-rz(j)
                     call calc_replica(sdx,sdy,sdz,frc,ix,iy,iz,istat)
                     if (istat == 1) then
                        r2=sdx**2+sdy**2+sdz**2
                        if (r2 < frc2) then
                           kn=kn+1
                           kns=kns+1
                        endif
                     endif
                  enddo; enddo; enddo
               endif
            enddo
            knum(k)=kn
         enddo
         nbook=kns*1.5
         allocate (idpt(nbook,4))
      endif
!!! Count end

      kns=0
      do k=1,n
         kn=0
         sxk=rx(k)
         syk=ry(k)
         szk=rz(k)
         do j=1,n
            if ((nrpx<=1).and.(nrpy<=1).and.(nrpz<=1)) then
               sdx=sxk-rx(j)
               sdy=syk-ry(j)
               sdz=szk-rz(j)
               call search_neighbor(sdx,sdy,sdz,frc,ix,iy,iz,istat)
               if (istat == 1) then
                  r2=sdx**2+sdy**2+sdz**2
                  if (r2 < frc2) then
                     kn=kn+1
                     kns=kns+1
                     if (kns <= nbook) then
                        idpt(kns,1)=j
                        idpt(kns,2)=ix
                        idpt(kns,3)=iy
                        idpt(kns,4)=iz
                     else
                        print *,'nbook should be larger. expanded.'
                        print *,'Pls set larger nbook to save time'
                        deallocate (idpt)
                        go to 5000
                     endif
                  endif
               endif
            else
               do ix=-nrpx,nrpx; do iy=-nrpy,nrpy; do iz=-nrpz,nrpz
                  sdx=sxk-rx(j)
                  sdy=syk-ry(j)
                  sdz=szk-rz(j)
                  call calc_replica(sdx,sdy,sdz,frc,ix,iy,iz,istat)
                  if (istat == 1) then
                     r2=sdx**2+sdy**2+sdz**2
                     if (r2 < frc2) then
                        kn=kn+1
                        kns=kns+1
                        if (kns <= nbook) then
                           idpt(kns,1)=j
                           idpt(kns,2)=ix
                           idpt(kns,3)=iy
                           idpt(kns,4)=iz
                        else
                           print *,'nbook should be larger. expanded.'
                           print *,'Pls set larger nbook to save time'
                           deallocate (idpt)
                           go to 5000
                        endif
                     endif
                  endif
               enddo; enddo; enddo
            endif
         end do
         knum(k)=kn
      end do
      if (ilog == 1) then
         print *,'NUMBER OF BOOKKEEPING : ',kns
      endif
!      if (kns.gt.nbook) then
!         print *,'!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
!         print *,'!!! ERROR in BOOKKEEPING !!!'              
!         print *,'!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
!      endif

      atime=dtime(btime)
      print *,'Bookkeep (DOUBLE algorithm)',btime,'  sec'
      return

      end


