      subroutine mtable
        use bre_commons
      implicit double precision(a-h,o-z)
!      include 'common_files.inc'

!c
!c generate lookup tables for bond-order potentials
!c
!      open(50,FILE='test.d')
      do ki=1,4
            do kj = ki,4
                 ddtab(ki,kj) = rb2(ki,kj)/float(ntab - 2)
                 ddtab(kj,ki) = ddtab(ki,kj)
                 rc = 0.0d0
                 do i=2,ntab-1
                   if(ddtab(ki,kj).ne.0.0d0) then
                      rc = rc + ddtab(ki,kj)
                      rsq = rc*rc
!c cut-off function
                      fc=0.0d0
                      dfc=0.0d0
!c
                      if(rc.lt.rb2(ki,kj)) then
                           dtemp=pid(ki,kj)*(rc-rb1(ki,kj))
                           fc=(1.0d0+cos(dtemp))/2.0d0
                           dfc=-pid(ki,kj)/2.0d0*sin(dtemp)
                      endif
!c
                      if(rc.le.rb1(ki,kj)) then
                           fc=1.0d0
                           dfc=0.0d0
                      endif
!                      if ((ki==3).and.(kj==3)) write (50,*) rc,fc,dfc

                      tabfc(ki,kj,i) = fc
                      tabfc(kj,ki,i) = tabfc(ki,kj,i)
                      tabdfc(ki,kj,i) = dfc
                      tabdfc(kj,ki,i) = tabdfc(ki,kj,i)
!c attractive pair terms
                      va=ad(ki,kj)*exp(-axl(ki,kj)*rc)
                      dva=-axl(ki,kj)*va
!c
                      vb=bd(ki,kj)*exp(-bxl(ki,kj)*rc)
                      dvb=-bxl(ki,kj)*vb
!c
                      vc=cd(ki,kj)*exp(-cxl(ki,kj)*rc)
                      dvc=-cxl(ki,kj)*vc
!c
                      vv=(va+vb+vc)/2.0d0
                      dvv=(dva+dvb+dvc)/2.0d0
                      atable(ki,kj,i) = fc*vv
                      atable(kj,ki,i) = atable(ki,kj,i)
                      datable(ki,kj,i) = (fc*dvv+dfc*vv)/rc
                      datable(kj,ki,i) = datable(ki,kj,i)
!c repulsive pair terms
                      ff1=dd(ki,kj)*exp(-dxl(ki,kj)*rc)
                      df1=-dxl(ki,kj)*ff1
!c
                      ff2=(1.0d0+ed(ki,kj)/rc)
                      df2=-ed(ki,kj)/rsq
!c
                      vv=ff1*ff2
                      dvm=(df1*ff2 + ff1*df2)
                      rtable(ki,kj,i) = vv*fc
                      rtable(kj,ki,i) = rtable(ki,kj,i)
                      drtable(ki,kj,i) = -(fc*dvm+dfc*vv)/rc
                      drtable(kj,ki,i) = drtable(ki,kj,i)
                   else
                      tabfc(ki,kj,i)=0.0d0
                      tabfc(kj,ki,i) = tabfc(ki,kj,i)
                      tabdfc(ki,kj,i) = 0.0d0
                      tabdfc(kj,ki,i) = tabdfc(ki,kj,i)
                      atable(ki,kj,i) = 0.0d0
                      atable(kj,ki,i) = atable(ki,kj,i)
                      datable(ki,kj,i) = 0.0d0
                      datable(kj,ki,i) = datable(ki,kj,i)
                      rtable(ki,kj,i) = 0.0d0
                      rtable(kj,ki,i) = rtable(ki,kj,i)
                      drtable(ki,kj,i) = 0.0d0
                      drtable(kj,ki,i) = drtable(ki,kj,i)
                   endif 
                 enddo

                 atable(ki,kj,1) = atable(ki,kj,2)
                 atable(kj,ki,1) = atable(ki,kj,1)
                 datable(ki,kj,1) = datable(ki,kj,2)
                 datable(kj,ki,1) = datable(ki,kj,1)
                 rtable(ki,kj,1) = rtable(ki,kj,2)
                 rtable(kj,ki,1) = rtable(ki,kj,1)
                 drtable(ki,kj,1) = drtable(ki,kj,2)
                 drtable(kj,ki,1) = drtable(ki,kj,1)
                 tabfc(ki,kj,1) = 0.0d0
                 tabfc(kj,ki,1) = 0.0d0
                 tabdfc(ki,kj,1) = 0.0d0
                 tabdfc(kj,ki,1) = 0.0d0

                 atable(ki,kj,ntab) = 0.0d0
                 atable(kj,ki,ntab) = atable(ki,kj,ntab)
                 datable(ki,kj,ntab) = 0.0d0
                 datable(kj,ki,ntab) = datable(ki,kj,ntab)
                 rtable(ki,kj,ntab) = 0.0d0
                 rtable(kj,ki,ntab) = rtable(ki,kj,ntab)
                 drtable(ki,kj,ntab) = 0.0d0
                 drtable(kj,ki,ntab) = drtable(ki,kj,ntab)
                 tabfc(ki,kj,ntab) = 0.0d0
                 tabfc(kj,ki,ntab) = tabfc(ki,kj,ntab)
                 tabdfc(ki,kj,ntab) = 0.0d0
                 tabdfc(kj,ki,ntab) = tabdfc(ki,kj,ntab)

            enddo
       enddo
!c
       return
       end

