      subroutine radic(ki,kj,xnt1,xnt2,conjug,rad,drdl,drdm,drdn)
        use bre_commons
      implicit double precision(a-h,o-z)
!c
!      include 'common_files.inc'
!c
!c tricubic spline
!c
!c conjug=1: nonconjugated
!c       >1: conjugated
!c
      l=int(xnt1)
      m=int(xnt2)
      n=int(conjug)
      rad=0.0d0
      drdl=0.0d0
      drdm=0.0d0
      drdn=0.0d0
      kikj = ki + kj - 1
!c
      if(l.ge.4) then
           l=4
           xnt1=4.0d0
      endif
!c
      if(m.ge.4) then
           m=4
           xnt2=4.0d0
      endif
!c
      if(n.ge.9) then
           n=9
           conjug=9.0d0
      endif
!c
      do 32 j=1,64
           x=clmn(kikj,l,m,n,j)* &
                (xnt1**in3(j,1))*(xnt2**in3(j,2))*(conjug**in3(j,3))
           rad=rad+x
           drdl=drdl+x*in3(j,1)/xnt1
           drdm=drdm+x*in3(j,2)/xnt2
           drdn=drdn+x*in3(j,3)/conjug
32    continue
      return
      end
!c

      subroutine tor(xnt1,xnt2,conjug,ator,drdl,drdm,drdn)
        use bre_commons
      implicit double precision(a-h,o-z)
!c
!      include 'common_files.inc'
!c
!c tricubic spline for torsional interaction
!c
!c conjug=1: nonconjugated
!c       >1: conjugated
!c
      ator=0.0d0
      drdl=0.0d0
      drdm=0.0d0
      drdn=0.0d0
      if((xnt1.ge.4.0d0).or.(xnt2.ge.4.0d0)) return
      l=int(xnt1)
      m=int(xnt2)
      n=int(conjug)
      do 32 j=1,64
           x=tlmn(l,m,n,j)* &
                (xnt1**in3(j,1))*(xnt2**in3(j,2))*(conjug**in3(j,3))
           ator=ator+x
           drdl=drdl+x*in3(j,1)/xnt1
           drdm=drdm+x*in3(j,2)/xnt2
           drdn=drdn+x*in3(j,3)/conjug
32    continue
!c
      return 
      end

!c
      subroutine bcuint(kl,ki,xx1,xx2,nh,nc,ansy,ansy1,ansy2)
        use bre_commons
!c
!c bicubic spline
!c
      implicit double precision(a-h,o-z)
!c
!c      include 'common_files.inc'
!c
      ansy=0.0d0
      ansy1=0.0d0
      ansy2=0.0d0
!c
      if((ki.eq.0).or.(nh.eq.0).or.(nc.eq.0)) then
           write(6,*) ki,kl,nh,nc
!           include 'close.inc'
           stop
      endif
!c
      do 32 j=1,16
           x=clm(ki,nh,nc,j)* &
                (xx1**in2(j,1))*(xx2**in2(j,2))
           ansy=ansy+x
           ansy1=ansy1+x*in2(j,1)/xx1
           ansy2=ansy2+x*in2(j,2)/xx2
32    continue
!c
      return
      end

