!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!   CELL RELAXATION
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      SUBROUTINE cellrlx
      use variables
      use constants
      implicit double precision (a-h,o-z)
      
      DOUBLE PRECISION :: PT(3,3) ! PRESSURE TENSOR
      DOUBLE PRECISION :: TM(3,3) ! MATRIX FOR TEMPORARY USE
      DOUBLE PRECISION :: HF(3,3) ! FOR CALCULATION OF CORRECTOR FOR HMAT
      
!  SCALING FACTOR FOR CELL CHANGE
      FACTOR=1.33d-20**2/ww

!  Inverse cell matrix
      CALL INVERSE (HMAT,HINMAT)
!  CALC VOLUME
      CALL CALCVOLUME

!  Kinetic energy has to be calculated using P. Not V.
!  PRESSURE TENSOR IS ALSO CALCULATED.
      enkin = 0.0D0; enpoteach=0.0d0
      PT = 0.0D0
      TM = MATMUL(HVMAT,HINMAT)
      DO I = 1, N
         XX = VX(I) - ( TM(1,1) * RX(I) + TM(1,2) * RY(I) + TM(1,3) * RZ(I) )
         YY = VY(I) - ( TM(2,1) * RX(I) + TM(2,2) * RY(I) + TM(2,3) * RZ(I) )
         ZZ = VZ(I) - ( TM(3,1) * RX(I) + TM(3,2) * RY(I) + TM(3,3) * RZ(I) )
         enkineach(i) = 0.5d0 * wm(i) * (XX ** 2 + YY ** 2 + ZZ ** 2)
         enkin = enkin + enkineach(i)
         PT(1,1) = PT(1,1) + XX * XX * WM(I)
         PT(2,1) = PT(2,1) + YY * XX * WM(I)
         PT(3,1) = PT(3,1) + ZZ * XX * WM(I)
         PT(1,2) = PT(1,2) + XX * YY * WM(I)
         PT(2,2) = PT(2,2) + YY * YY * WM(I)
         PT(3,2) = PT(3,2) + ZZ * YY * WM(I)
         PT(1,3) = PT(1,3) + XX * ZZ * WM(I)
         PT(2,3) = PT(2,3) + YY * ZZ * WM(I)
         PT(3,3) = PT(3,3) + ZZ * ZZ * WM(I)
      ENDDO
      PT = PT + DMAT
      PT = PT / V

      HF = PT - PEXMAT

      CALL MKQ

      HMAT = HMAT+HF*FACTOR

      CALL CALCVOLUME

      do k=1,n
         rx(k)=hmat(1,1)*qx(k)+hmat(1,2)*qy(k)+hmat(1,3)*qz(k)
         ry(k)=hmat(2,1)*qx(k)+hmat(2,2)*qy(k)+hmat(2,3)*qz(k)
         rz(k)=hmat(3,1)*qx(k)+hmat(3,2)*qy(k)+hmat(3,3)*qz(k)
      enddo
      
      RETURN
      END

