      subroutine forcecheck
      use variables
      use constants
      use debug_variables
      implicit double precision (a-h,o-z)
      dis=4.0d-10/5000.0d0        ! Infinitesimal displacement for F check
      dis=1.0d-13
      threshold=30.0             ! Error exceeding this value is shown

      write (6,'("Force check ...")')

      loop: do i=1,n

      rxk=rx(i)
      ryk=ry(i)
      rzk=rz(i)

      call potential
      fx_cal=fx(i)
      fy_cal=fy(i)
      fz_cal=fz(i)

      rx(i)=rxk-dis
      call potential
      enpot0=enpot
      rx(i)=rxk+dis
      call potential
      fx_ene=-(enpot-enpot0)/(dis*2.0)
      rx(i)=rxk
      err=abs(fx_cal/fx_ene*100.0-100)
      if (fx_ene==0.0) err=-1.0
      if (abs(err)>threshold) then
         write (6,'("x,#=",i4,1x,"Exact:",e10.4,1x,"Calc F:",e10.4,1x,"Err(%)",f8.2)')&
              i,fx_ene,fx_cal,err
         write (6,'("x,#=",i4,1x,"Atom position:",e10.4,1x,e10.4,1x,e10.4)')&
              i,rx(i),ry(i),rz(i)
!         write (6,'("x,#=",i4,x,"Nei-atoms:",i4,x,"Density term(s):",e18.8,x,e18.8)') i,nn(i),den1(i),den2(i)
!         do j=1,n
!            if (nnnum(i,j)/=0) write (6,'(i4,i4,5e12.4)') i,j,distance(i,j),fcom(i,j,1),fcom(i,j),fcom(i,j,3)
!         enddo
         write (6,*)
      endif

      ry(i)=ryk-dis
      call potential
      enpot0=enpot
      ry(i)=ryk+dis
      call potential
      fy_ene=-(enpot-enpot0)/(dis*2.0)
      ry(i)=ryk
      err=abs(fy_cal/fy_ene*100.0-100)
      if (fy_ene==0.0) err=-1.0
      if (abs(err)>threshold) then
         write (6,'("y,#=",i4,1x,"Exact:",e10.4,1x,"Calc F:",e10.4,1x,"Err(%)",f8.2)') i,fy_ene,fy_cal,err
         write (6,'("y,#=",i4,1x,"Atom position:",e10.4,1x,e10.4,1x,e10.4)') i,rx(i),ry(i),rz(i)
         write (6,*)
      endif

      rz(i)=rzk-dis
      call potential
      enpot0=enpot
      rz(i)=rzk+dis
      call potential
      fz_ene=-(enpot-enpot0)/(dis*2.0)
      rz(i)=rzk
      err=abs(fz_cal/fz_ene*100.0-100)
      if (fz_ene==0.0) err=-1.0
      if (abs(err)>threshold) then
         write (6,'("z,#=",i4,1x,"Exact:",e10.4,1x,"Calc F:",e10.4,1x,"Err(%)",f8.2)') i,fz_ene,fz_cal,err
         write (6,'("z,#=",i4,1x,"Atom position:",e10.4,1x,e10.4,1x,e10.4)') i,rx(i),ry(i),rz(i)
         write (6,*)
      endif

      enddo loop
      
      end
